/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Menu Editor.
 *
 * The Initial Developer of the Original Code is
 * Devon Jensen.
 *
 * Portions created by the Initial Developer are Copyright (C) 2003
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s): Devon Jensen <velcrospud@hotmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var mep_RDFC = '@mozilla.org/rdf/container;1';
mep_RDFC = Components.classes[mep_RDFC].createInstance();
mep_RDFC = mep_RDFC.QueryInterface(Components.interfaces.nsIRDFContainer);

var mep_RDFCUtils = '@mozilla.org/rdf/container-utils;1';
mep_RDFCUtils = Components.classes[mep_RDFCUtils].getService();
mep_RDFCUtils = mep_RDFCUtils.QueryInterface(Components.interfaces.nsIRDFContainerUtils);

var mep_RDF = '@mozilla.org/rdf/rdf-service;1';
mep_RDF = Components.classes[mep_RDF].getService();
mep_RDF = mep_RDF.QueryInterface(Components.interfaces.nsIRDFService);

var mep_datasource;

function init() {
	var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	// From TBE
	const DIR = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties);
	var dir = DIR.get('ProfD', Components.interfaces.nsILocalFile);

	var tempLocalFile = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile);
	tempLocalFile.initWithPath(dir.path);

	var mep_uri;
	try {
		mep_uri = gIOService.newFileURI(tempLocalFile).spec;
	}
	catch(e) {}

	if (!mep_uri.match(/\/$/)) mep_uri += '/';
	// /from TBE
	//d(mep_uri);
	
	mep_datasource = mep_RDF.GetDataSourceBlocking(mep_uri + "menuedit.rdf");
	var root = mep_RDF.GetResource("NC:ContextRoot");
	
	try {
      mep_RDFC.Init(mep_datasource,root);
    } catch (e) {
      mep_RDFCUtils.MakeSeq(mep_datasource,root);
      mep_RDFC.Init(mep_datasource,root);
    }	
	
	var mainlistbox = document.getElementById("mainListbox");
	mainlistbox.database.AddDataSource(mep_datasource);
	mainlistbox.builder.rebuild();
	
	if(mainlistbox.childNodes.length == 1) //First time run
		reset(true);
	
	
	//var rdfsource = mep_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	//rdfsource.Flush();
}

function saveSettings() {
	
	var rdfsource = mep_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	rdfsource.Flush();
	
	if (!document.getElementById("me_applyButton").disabled) {
		try {
		  	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		  	var browserWindows = wm.getEnumerator("navigator:browser");
		  	while (browserWindows.hasMoreElements()) {
				bwindow = browserWindows.getNext();
		  		bwindow.moveToTemp();
		  		bwindow.populateMenu();
	  		}
  		} catch (e){}
  		var root = mep_RDF.GetResource("NC:ContextRoot");
		var rootCont = mep_RDFCUtils.MakeSeq(mep_datasource,root);
		var newlength = rootCont.GetCount();
  		var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		try {
			pref.setIntPref("menuedit.current.menuitems", newlength);
			//d("prefset: " + newlength);
		} catch (e){}
	
	}

	document.getElementById("me_applyButton").disabled = true;
	
	//d("done");
}

function dontSave(){
	var rdfsource = mep_datasource.QueryInterface(Components.interfaces.nsIRDFRemoteDataSource);
	rdfsource.Refresh(true);
	//d("didn'tsave");
	
}

function toggleShow() {
	document.getElementById("me_applyButton").disabled = false;
	var listbox = document.getElementById("mainListbox");
	var listelem = listbox.selectedItem;
	var currIndex = listbox.selectedIndex;
	var currID = listelem.id;
	//d(currIndex);
	
	if (listelem.disabled){
		var showLit = mep_RDF.GetIntLiteral(1);
		var node = mep_RDF.GetResource(currID);
		var arcShow = mep_RDF.GetResource("http://home.netscape.com/NC-rdf#show");
		var targetExists = mep_datasource.GetTarget(node, arcShow, true);
		if(targetExists != null)
			mep_datasource.Change(node, arcShow, targetExists, showLit);
		//d("enabled");
	}
	else {
		var showLit = mep_RDF.GetIntLiteral(0);
		var node = mep_RDF.GetResource(currID);
		var arcShow = mep_RDF.GetResource("http://home.netscape.com/NC-rdf#show");
		var targetExists = mep_datasource.GetTarget(node, arcShow, true);
		if(targetExists != null)
			mep_datasource.Change(node, arcShow, targetExists, showLit);
		//d("disabled");
	}
	//listbox.builder.rebuild();
	//listbox.ensureIndexIsVisible(currIndex);
	listbox.selectedIndex = currIndex; 
	listbox.focus();
}

function moveItemUp() {
	document.getElementById("me_applyButton").disabled = false;
	var listbox = document.getElementById("mainListbox");
	var listelem = listbox.selectedItem;
	var currIndex = listbox.selectedIndex;
	
	if(currIndex == 0) {
		listbox.focus();
		return;
	}
	
	currIndex++;
	var root = mep_RDF.GetResource("NC:ContextRoot");
	var rootCont = mep_RDFCUtils.MakeSeq(mep_datasource,root);
	var node = rootCont.RemoveElementAt(currIndex, true);
	rootCont.InsertElementAt(node, currIndex - 1, true);
	
	listbox.selectedIndex = currIndex - 2;
	listbox.ensureIndexIsVisible(currIndex - 2);
	listbox.focus();
}

function moveItemDown() {
	document.getElementById("me_applyButton").disabled = false;
	var listbox = document.getElementById("mainListbox");
	var listelem = listbox.selectedItem;
	var currIndex = listbox.selectedIndex;
	
	if(currIndex == listbox.childNodes.length - 2) {
		listbox.focus();
		return;
	}
	
	currIndex++;
	var root = mep_RDF.GetResource("NC:ContextRoot");
	var rootCont = mep_RDFCUtils.MakeSeq(mep_datasource,root);
	var node = rootCont.RemoveElementAt(currIndex, true);
	rootCont.InsertElementAt(node, currIndex + 1, true);
	
	listbox.selectedIndex = currIndex;
	listbox.ensureIndexIsVisible(currIndex); 
	listbox.focus();

}

function findNew() {
	document.getElementById("me_applyButton").disabled = false;
	try {
	  	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	  	var wrecent = wm.getMostRecentWindow("navigator:browser");
	  	wrecent.discoverNew();
	  }
	catch (e){}
	
}

function reset(skipConfirm) {
	if (!skipConfirm) {
		var mep_stringsPref = document.getElementById("prefmenueditbundle");
		var mep_confirmTxt = mep_stringsPref.getString("reset");
		if(!confirm(mep_confirmTxt)) return;
	}

	document.getElementById("me_applyButton").disabled = false;
	try {
	  	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
	  	var wrecent = wm.getMostRecentWindow("navigator:browser");
	  	var contextPopup = wrecent.document.getElementById("contextMenuBackup");
	  }
	catch (e){}
	 
	var root = mep_RDF.GetResource("NC:ContextRoot");
	var rootCont = mep_RDFCUtils.MakeSeq(mep_datasource, root);

	var num = rootCont.GetCount();
	for(var i=1; i<=num; ++i){ // Remove all current items
			rootCont.RemoveElementAt(1, true);
	}
	var currentID, currentLabel, node, nameLit, name, targetExists;
	var arcShow = mep_RDF.GetResource("http://home.netscape.com/NC-rdf#show");
	var arcName = mep_RDF.GetResource("http://home.netscape.com/NC-rdf#name");
	var showLit = mep_RDF.GetIntLiteral(1);
	var contextCount = contextPopup.childNodes.length;
	
	for(var j=0; j <= contextCount-1; ++j) {
		//d(j);
		currentID = contextPopup.childNodes[j].id;
		currentLabel = contextPopup.childNodes[j].label;
		if (currentLabel && currentLabel != "") {
			name = currentLabel;
		}
		else if (currentID.substring(0, 12) == "context-sep-"){
			//d("Seperator");
			name = "--Separator-- (" + currentID.substring(12, currentID.length) + ")";
		}
		else {
			if (currentID == "context-blockimage")
				name = "Block images from...";
			else if (currentID == "context-searchselect")
				name = "Search web for...";
			else if (currentID == "frame-sep")
				name = "--Separator-- (frame)";
			else if (currentID == "frame")
				name = "Frame Menu ->";
			else
				name = currentID;  //Otherwise just use the ID - this is likely to happen if an extension adds a menuitem without a default label
			//d("!!! " + name);
			
		}
		
		node = mep_RDF.GetResource("http://home.netscape.com/NC-rdf#" + currentID);
		rootCont.AppendElement(node);
		nameLit = mep_RDF.GetLiteral(name);
		
		targetExists = mep_datasource.GetTarget(node, arcShow, true);
		if(targetExists != null) 
			mep_datasource.Change(node, arcShow, targetExists, showLit);
		else
			mep_datasource.Assert(node, arcShow, showLit, true);
		
		targetExists = mep_datasource.GetTarget(node, arcName, true);
		if(targetExists != null) 
			mep_datasource.Change(node, arcName, targetExists, nameLit);
		else
			mep_datasource.Assert(node, arcName, nameLit, true);
		
	}
	
	var mainlistbox = document.getElementById("mainListbox");
	mainlistbox.builder.rebuild();
	window.sizeToContent();
}

/*Hold down control to override the menuedit menus and use the default, override the onclick of the 
tabbrowser and check the event for rightclick button and control key, set value on contentcontext 
back to original momentarily.*/